import { extractDirectedRelation } from './helpers.js';
import { filterFieldOptions } from './filter.js';
import { validateField } from './validate.js';
import { afterListChange } from './hooks.js';
export const relationList = (config, direction)=>{
    const { here, there } = extractDirectedRelation(config, direction);
    return {
        ...config[`vertex${direction == 'A->B' ? 'A' : 'B'}`].listOptions,
        name: here.list,
        type: 'array',
        fields: [
            {
                ...config[`vertex${direction == 'A->B' ? 'A' : 'B'}`].fieldOptions,
                name: here.field,
                type: 'relationship',
                relationTo: there.collection,
                filterOptions: filterFieldOptions(config, direction),
                validate: validateField(config, direction)
            },
            ...config.relationMeta
        ],
        hooks: {
            afterChange: [
                afterListChange(config, direction)
            ]
        }
    };
};

//# sourceMappingURL=field.js.map