import { GeneratedTypes } from 'payload';
import { PayloadRequest, RequestContext } from 'payload/types';
import { DirectedRelation, RelatableCollection, RelationConfig, RelationDirection, RelationList, RelationValue } from './types.js';
export declare const extractDirectedRelation: <G extends GeneratedTypes, Config extends RelationConfig<G>, Arrow extends RelationDirection>(config: RelationConfig<G>, direction: Arrow) => DirectedRelation<G, Config, Arrow>;
export declare const getId: <G extends GeneratedTypes, C extends Exclude<keyof G["collections"], "payload-preferences" | "payload-migrations">>(entry: RelationValue<G, C> | undefined) => string | number | undefined;
export declare const getList: <G extends GeneratedTypes, Config extends RelationConfig<G>, Arrow extends RelationDirection>(config: Config, direction: Arrow, data: Partial<RelatableCollection<G>[DirectedRelation<G, Config, Arrow>['here']['collection']]>) => RelationList;
export declare const couple: <G extends GeneratedTypes, Config extends RelationConfig<G>, Arrow extends RelationDirection>(docHere: RelationValue<G, DirectedRelation<G, Config, Arrow>['here']['collection']>, relationEntries: RelationList, config: Config, direction: Arrow, req: PayloadRequest, mode: 'decoupling' | 'recoupling', context: RequestContext) => Promise<void>;
export declare const entriesEqual: (entry1: Record<string, any>, entry2: Record<string, any>, field: string) => boolean;
export declare const deepComparison: (object1: Record<string, any>, object2: Record<string, any>) => boolean;
//# sourceMappingURL=helpers.d.ts.map