import { couple, entriesEqual, extractDirectedRelation, getId, getList } from './helpers.js';
export const afterListChange = (config, direction)=>async ({ originalDoc, value, previousValue, req, context })=>{
        if (value && originalDoc) {
            const { here: { field } } = extractDirectedRelation(config, direction);
            const newIds = value.map((entry)=>getId(entry[field])).filter((id)=>id);
            let deletedEntries = previousValue?.filter((oldEntry)=>!newIds.includes(getId(oldEntry[field]) ?? ''));
            if (context.deletionCameFrom) deletedEntries = deletedEntries?.filter((entry)=>getId(entry[field]) != context.deletionCameFrom);
            if (deletedEntries?.length) await couple(originalDoc, deletedEntries, config, direction, req, 'decoupling', context);
            let changedEntries = value.filter((newEntry)=>!previousValue?.filter((oldEntry)=>entriesEqual(newEntry, oldEntry, field)).length);
            if (context.updateCameFrom) changedEntries = changedEntries.filter((entry)=>getId(entry[field]) != context.updateCameFrom);
            if (changedEntries.length) await couple(originalDoc, changedEntries, config, direction, req, 'recoupling', context);
        }
        return null;
    };
export const afterDocumentDelete = (config, direction)=>async ({ doc, req, context })=>couple(doc, getList(config, direction, doc), config, direction, req, 'decoupling', {
            ...context,
            deletionCameFrom: doc.id
        });

//# sourceMappingURL=hooks.js.map